// This may look like C code, but it is really -*- C++ -*-
/*
 ************************************************************************
 *
 *			   UNT Virtual Machine
 *
 * This file describes the configuarion of the virtual computer,
 * i.e. all the pieces it is built from
 *
 ************************************************************************
 */

#ifndef _computer_h
#define _computer_h 1
#pragma interface

#include "hardware.h"

class Computer
{
public:
  Memory memory;
  CentralProcessingUnit CPU;
  IOBus io_bus;
  CardReader card_reader;
  LinePrinter line_printer;
  HardDisk hard_disk;

public:
  Computer(void) : CPU(memory), card_reader(memory,io_bus),
  		   line_printer(memory,io_bus),
  		   hard_disk(memory,io_bus) {}

  ~Computer(void) {}
};

#endif

