// This may look like C code, but it is really -*- C++ -*-
/*
 ************************************************************************
 *
 *			   UNT Virtual Machine
 *
 * 		This is the core of the operating system
 *
 * This file describes the configuarion of the OS,
 * i.e. all the pieces it is built from
 *
 ************************************************************************
 */

#ifndef _oper_system_h
#define _oper_system_h 1
#pragma interface

#include "computer.h"
#include "cpu_manager.h"
#include "mem_manager.h"
#include "io_manager.h"

class OperatingSystem : public Computer
{
public:
  MemoryManager mem_manager;
  CPUManager    cpu_manager;
  IOManager     io_manager;
  IOChannelManager cr_dev_manager;
  IOChannelManager lp_dev_manager;
  IOChannelManager hd_dev_manager;

public:
  OperatingSystem(void) : cpu_manager(CPU,mem_manager,io_manager), 
		mem_manager(memory), io_manager(cpu_manager),
  	        cr_dev_manager(card_reader,io_manager),
  		lp_dev_manager(line_printer,io_manager),
  	        hd_dev_manager(hard_disk,io_manager)
  {}
  ~OperatingSystem(void) {}
};

#endif
